/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// ProductOrderItem An identified part of the order. A product order is decomposed into one or more order items.
type ProductOrderItem struct {
	// Identifier of the line item (generally it is a sequence number 01, 02, 03, ...)
	Id string `json:"id"`
	// Quantity ordered
	Quantity *int32 `json:"quantity,omitempty"`
	Action OrderItemActionType `json:"action"`
	Appointment *AppointmentRef `json:"appointment,omitempty"`
	BillingAccount *BillingAccountRef `json:"billingAccount,omitempty"`
	ItemPrice *[]OrderPrice `json:"itemPrice,omitempty"`
	ItemTerm *[]OrderTerm `json:"itemTerm,omitempty"`
	ItemTotalPrice *[]OrderPrice `json:"itemTotalPrice,omitempty"`
	Payment *[]PaymentRef `json:"payment,omitempty"`
	Product *ProductRefOrValue `json:"product,omitempty"`
	ProductOffering *ProductOfferingRef `json:"productOffering,omitempty"`
	ProductOfferingQualificationItem *ProductOfferingQualificationItemRef `json:"productOfferingQualificationItem,omitempty"`
	ProductOrderItem *[]ProductOrderItem `json:"productOrderItem,omitempty"`
	ProductOrderItemRelationship *[]OrderItemRelationship `json:"productOrderItemRelationship,omitempty"`
	Qualification *[]ProductOfferingQualificationRef `json:"qualification,omitempty"`
	QuoteItem *QuoteItemRef `json:"quoteItem,omitempty"`
	State *ProductOrderItemStateType `json:"state,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewProductOrderItem instantiates a new ProductOrderItem object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProductOrderItem(id string, action OrderItemActionType, ) *ProductOrderItem {
	this := ProductOrderItem{}
	this.Id = id
	this.Action = action
	return &this
}

// NewProductOrderItemWithDefaults instantiates a new ProductOrderItem object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductOrderItemWithDefaults() *ProductOrderItem {
	this := ProductOrderItem{}
	return &this
}

// GetId returns the Id field value
func (o *ProductOrderItem) GetId() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ProductOrderItem) SetId(v string) {
	o.Id = v
}

// GetQuantity returns the Quantity field value if set, zero value otherwise.
func (o *ProductOrderItem) GetQuantity() int32 {
	if o == nil || o.Quantity == nil {
		var ret int32
		return ret
	}
	return *o.Quantity
}

// GetQuantityOk returns a tuple with the Quantity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetQuantityOk() (*int32, bool) {
	if o == nil || o.Quantity == nil {
		return nil, false
	}
	return o.Quantity, true
}

// HasQuantity returns a boolean if a field has been set.
func (o *ProductOrderItem) HasQuantity() bool {
	if o != nil && o.Quantity != nil {
		return true
	}

	return false
}

// SetQuantity gets a reference to the given int32 and assigns it to the Quantity field.
func (o *ProductOrderItem) SetQuantity(v int32) {
	o.Quantity = &v
}

// GetAction returns the Action field value
func (o *ProductOrderItem) GetAction() OrderItemActionType {
	if o == nil  {
		var ret OrderItemActionType
		return ret
	}

	return o.Action
}

// GetActionOk returns a tuple with the Action field value
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetActionOk() (*OrderItemActionType, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Action, true
}

// SetAction sets field value
func (o *ProductOrderItem) SetAction(v OrderItemActionType) {
	o.Action = v
}

// GetAppointment returns the Appointment field value if set, zero value otherwise.
func (o *ProductOrderItem) GetAppointment() AppointmentRef {
	if o == nil || o.Appointment == nil {
		var ret AppointmentRef
		return ret
	}
	return *o.Appointment
}

// GetAppointmentOk returns a tuple with the Appointment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetAppointmentOk() (*AppointmentRef, bool) {
	if o == nil || o.Appointment == nil {
		return nil, false
	}
	return o.Appointment, true
}

// HasAppointment returns a boolean if a field has been set.
func (o *ProductOrderItem) HasAppointment() bool {
	if o != nil && o.Appointment != nil {
		return true
	}

	return false
}

// SetAppointment gets a reference to the given AppointmentRef and assigns it to the Appointment field.
func (o *ProductOrderItem) SetAppointment(v AppointmentRef) {
	o.Appointment = &v
}

// GetBillingAccount returns the BillingAccount field value if set, zero value otherwise.
func (o *ProductOrderItem) GetBillingAccount() BillingAccountRef {
	if o == nil || o.BillingAccount == nil {
		var ret BillingAccountRef
		return ret
	}
	return *o.BillingAccount
}

// GetBillingAccountOk returns a tuple with the BillingAccount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetBillingAccountOk() (*BillingAccountRef, bool) {
	if o == nil || o.BillingAccount == nil {
		return nil, false
	}
	return o.BillingAccount, true
}

// HasBillingAccount returns a boolean if a field has been set.
func (o *ProductOrderItem) HasBillingAccount() bool {
	if o != nil && o.BillingAccount != nil {
		return true
	}

	return false
}

// SetBillingAccount gets a reference to the given BillingAccountRef and assigns it to the BillingAccount field.
func (o *ProductOrderItem) SetBillingAccount(v BillingAccountRef) {
	o.BillingAccount = &v
}

// GetItemPrice returns the ItemPrice field value if set, zero value otherwise.
func (o *ProductOrderItem) GetItemPrice() []OrderPrice {
	if o == nil || o.ItemPrice == nil {
		var ret []OrderPrice
		return ret
	}
	return *o.ItemPrice
}

// GetItemPriceOk returns a tuple with the ItemPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetItemPriceOk() (*[]OrderPrice, bool) {
	if o == nil || o.ItemPrice == nil {
		return nil, false
	}
	return o.ItemPrice, true
}

// HasItemPrice returns a boolean if a field has been set.
func (o *ProductOrderItem) HasItemPrice() bool {
	if o != nil && o.ItemPrice != nil {
		return true
	}

	return false
}

// SetItemPrice gets a reference to the given []OrderPrice and assigns it to the ItemPrice field.
func (o *ProductOrderItem) SetItemPrice(v []OrderPrice) {
	o.ItemPrice = &v
}

// GetItemTerm returns the ItemTerm field value if set, zero value otherwise.
func (o *ProductOrderItem) GetItemTerm() []OrderTerm {
	if o == nil || o.ItemTerm == nil {
		var ret []OrderTerm
		return ret
	}
	return *o.ItemTerm
}

// GetItemTermOk returns a tuple with the ItemTerm field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetItemTermOk() (*[]OrderTerm, bool) {
	if o == nil || o.ItemTerm == nil {
		return nil, false
	}
	return o.ItemTerm, true
}

// HasItemTerm returns a boolean if a field has been set.
func (o *ProductOrderItem) HasItemTerm() bool {
	if o != nil && o.ItemTerm != nil {
		return true
	}

	return false
}

// SetItemTerm gets a reference to the given []OrderTerm and assigns it to the ItemTerm field.
func (o *ProductOrderItem) SetItemTerm(v []OrderTerm) {
	o.ItemTerm = &v
}

// GetItemTotalPrice returns the ItemTotalPrice field value if set, zero value otherwise.
func (o *ProductOrderItem) GetItemTotalPrice() []OrderPrice {
	if o == nil || o.ItemTotalPrice == nil {
		var ret []OrderPrice
		return ret
	}
	return *o.ItemTotalPrice
}

// GetItemTotalPriceOk returns a tuple with the ItemTotalPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetItemTotalPriceOk() (*[]OrderPrice, bool) {
	if o == nil || o.ItemTotalPrice == nil {
		return nil, false
	}
	return o.ItemTotalPrice, true
}

// HasItemTotalPrice returns a boolean if a field has been set.
func (o *ProductOrderItem) HasItemTotalPrice() bool {
	if o != nil && o.ItemTotalPrice != nil {
		return true
	}

	return false
}

// SetItemTotalPrice gets a reference to the given []OrderPrice and assigns it to the ItemTotalPrice field.
func (o *ProductOrderItem) SetItemTotalPrice(v []OrderPrice) {
	o.ItemTotalPrice = &v
}

// GetPayment returns the Payment field value if set, zero value otherwise.
func (o *ProductOrderItem) GetPayment() []PaymentRef {
	if o == nil || o.Payment == nil {
		var ret []PaymentRef
		return ret
	}
	return *o.Payment
}

// GetPaymentOk returns a tuple with the Payment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetPaymentOk() (*[]PaymentRef, bool) {
	if o == nil || o.Payment == nil {
		return nil, false
	}
	return o.Payment, true
}

// HasPayment returns a boolean if a field has been set.
func (o *ProductOrderItem) HasPayment() bool {
	if o != nil && o.Payment != nil {
		return true
	}

	return false
}

// SetPayment gets a reference to the given []PaymentRef and assigns it to the Payment field.
func (o *ProductOrderItem) SetPayment(v []PaymentRef) {
	o.Payment = &v
}

// GetProduct returns the Product field value if set, zero value otherwise.
func (o *ProductOrderItem) GetProduct() ProductRefOrValue {
	if o == nil || o.Product == nil {
		var ret ProductRefOrValue
		return ret
	}
	return *o.Product
}

// GetProductOk returns a tuple with the Product field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetProductOk() (*ProductRefOrValue, bool) {
	if o == nil || o.Product == nil {
		return nil, false
	}
	return o.Product, true
}

// HasProduct returns a boolean if a field has been set.
func (o *ProductOrderItem) HasProduct() bool {
	if o != nil && o.Product != nil {
		return true
	}

	return false
}

// SetProduct gets a reference to the given ProductRefOrValue and assigns it to the Product field.
func (o *ProductOrderItem) SetProduct(v ProductRefOrValue) {
	o.Product = &v
}

// GetProductOffering returns the ProductOffering field value if set, zero value otherwise.
func (o *ProductOrderItem) GetProductOffering() ProductOfferingRef {
	if o == nil || o.ProductOffering == nil {
		var ret ProductOfferingRef
		return ret
	}
	return *o.ProductOffering
}

// GetProductOfferingOk returns a tuple with the ProductOffering field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetProductOfferingOk() (*ProductOfferingRef, bool) {
	if o == nil || o.ProductOffering == nil {
		return nil, false
	}
	return o.ProductOffering, true
}

// HasProductOffering returns a boolean if a field has been set.
func (o *ProductOrderItem) HasProductOffering() bool {
	if o != nil && o.ProductOffering != nil {
		return true
	}

	return false
}

// SetProductOffering gets a reference to the given ProductOfferingRef and assigns it to the ProductOffering field.
func (o *ProductOrderItem) SetProductOffering(v ProductOfferingRef) {
	o.ProductOffering = &v
}

// GetProductOfferingQualificationItem returns the ProductOfferingQualificationItem field value if set, zero value otherwise.
func (o *ProductOrderItem) GetProductOfferingQualificationItem() ProductOfferingQualificationItemRef {
	if o == nil || o.ProductOfferingQualificationItem == nil {
		var ret ProductOfferingQualificationItemRef
		return ret
	}
	return *o.ProductOfferingQualificationItem
}

// GetProductOfferingQualificationItemOk returns a tuple with the ProductOfferingQualificationItem field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetProductOfferingQualificationItemOk() (*ProductOfferingQualificationItemRef, bool) {
	if o == nil || o.ProductOfferingQualificationItem == nil {
		return nil, false
	}
	return o.ProductOfferingQualificationItem, true
}

// HasProductOfferingQualificationItem returns a boolean if a field has been set.
func (o *ProductOrderItem) HasProductOfferingQualificationItem() bool {
	if o != nil && o.ProductOfferingQualificationItem != nil {
		return true
	}

	return false
}

// SetProductOfferingQualificationItem gets a reference to the given ProductOfferingQualificationItemRef and assigns it to the ProductOfferingQualificationItem field.
func (o *ProductOrderItem) SetProductOfferingQualificationItem(v ProductOfferingQualificationItemRef) {
	o.ProductOfferingQualificationItem = &v
}

// GetProductOrderItem returns the ProductOrderItem field value if set, zero value otherwise.
func (o *ProductOrderItem) GetProductOrderItem() []ProductOrderItem {
	if o == nil || o.ProductOrderItem == nil {
		var ret []ProductOrderItem
		return ret
	}
	return *o.ProductOrderItem
}

// GetProductOrderItemOk returns a tuple with the ProductOrderItem field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetProductOrderItemOk() (*[]ProductOrderItem, bool) {
	if o == nil || o.ProductOrderItem == nil {
		return nil, false
	}
	return o.ProductOrderItem, true
}

// HasProductOrderItem returns a boolean if a field has been set.
func (o *ProductOrderItem) HasProductOrderItem() bool {
	if o != nil && o.ProductOrderItem != nil {
		return true
	}

	return false
}

// SetProductOrderItem gets a reference to the given []ProductOrderItem and assigns it to the ProductOrderItem field.
func (o *ProductOrderItem) SetProductOrderItem(v []ProductOrderItem) {
	o.ProductOrderItem = &v
}

// GetProductOrderItemRelationship returns the ProductOrderItemRelationship field value if set, zero value otherwise.
func (o *ProductOrderItem) GetProductOrderItemRelationship() []OrderItemRelationship {
	if o == nil || o.ProductOrderItemRelationship == nil {
		var ret []OrderItemRelationship
		return ret
	}
	return *o.ProductOrderItemRelationship
}

// GetProductOrderItemRelationshipOk returns a tuple with the ProductOrderItemRelationship field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetProductOrderItemRelationshipOk() (*[]OrderItemRelationship, bool) {
	if o == nil || o.ProductOrderItemRelationship == nil {
		return nil, false
	}
	return o.ProductOrderItemRelationship, true
}

// HasProductOrderItemRelationship returns a boolean if a field has been set.
func (o *ProductOrderItem) HasProductOrderItemRelationship() bool {
	if o != nil && o.ProductOrderItemRelationship != nil {
		return true
	}

	return false
}

// SetProductOrderItemRelationship gets a reference to the given []OrderItemRelationship and assigns it to the ProductOrderItemRelationship field.
func (o *ProductOrderItem) SetProductOrderItemRelationship(v []OrderItemRelationship) {
	o.ProductOrderItemRelationship = &v
}

// GetQualification returns the Qualification field value if set, zero value otherwise.
func (o *ProductOrderItem) GetQualification() []ProductOfferingQualificationRef {
	if o == nil || o.Qualification == nil {
		var ret []ProductOfferingQualificationRef
		return ret
	}
	return *o.Qualification
}

// GetQualificationOk returns a tuple with the Qualification field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetQualificationOk() (*[]ProductOfferingQualificationRef, bool) {
	if o == nil || o.Qualification == nil {
		return nil, false
	}
	return o.Qualification, true
}

// HasQualification returns a boolean if a field has been set.
func (o *ProductOrderItem) HasQualification() bool {
	if o != nil && o.Qualification != nil {
		return true
	}

	return false
}

// SetQualification gets a reference to the given []ProductOfferingQualificationRef and assigns it to the Qualification field.
func (o *ProductOrderItem) SetQualification(v []ProductOfferingQualificationRef) {
	o.Qualification = &v
}

// GetQuoteItem returns the QuoteItem field value if set, zero value otherwise.
func (o *ProductOrderItem) GetQuoteItem() QuoteItemRef {
	if o == nil || o.QuoteItem == nil {
		var ret QuoteItemRef
		return ret
	}
	return *o.QuoteItem
}

// GetQuoteItemOk returns a tuple with the QuoteItem field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetQuoteItemOk() (*QuoteItemRef, bool) {
	if o == nil || o.QuoteItem == nil {
		return nil, false
	}
	return o.QuoteItem, true
}

// HasQuoteItem returns a boolean if a field has been set.
func (o *ProductOrderItem) HasQuoteItem() bool {
	if o != nil && o.QuoteItem != nil {
		return true
	}

	return false
}

// SetQuoteItem gets a reference to the given QuoteItemRef and assigns it to the QuoteItem field.
func (o *ProductOrderItem) SetQuoteItem(v QuoteItemRef) {
	o.QuoteItem = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *ProductOrderItem) GetState() ProductOrderItemStateType {
	if o == nil || o.State == nil {
		var ret ProductOrderItemStateType
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetStateOk() (*ProductOrderItemStateType, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *ProductOrderItem) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given ProductOrderItemStateType and assigns it to the State field.
func (o *ProductOrderItem) SetState(v ProductOrderItemStateType) {
	o.State = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *ProductOrderItem) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *ProductOrderItem) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *ProductOrderItem) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *ProductOrderItem) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *ProductOrderItem) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *ProductOrderItem) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ProductOrderItem) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderItem) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ProductOrderItem) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ProductOrderItem) SetType(v string) {
	o.Type = &v
}

func (o ProductOrderItem) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["id"] = o.Id
	}
	if o.Quantity != nil {
		toSerialize["quantity"] = o.Quantity
	}
	if true {
		toSerialize["action"] = o.Action
	}
	if o.Appointment != nil {
		toSerialize["appointment"] = o.Appointment
	}
	if o.BillingAccount != nil {
		toSerialize["billingAccount"] = o.BillingAccount
	}
	if o.ItemPrice != nil {
		toSerialize["itemPrice"] = o.ItemPrice
	}
	if o.ItemTerm != nil {
		toSerialize["itemTerm"] = o.ItemTerm
	}
	if o.ItemTotalPrice != nil {
		toSerialize["itemTotalPrice"] = o.ItemTotalPrice
	}
	if o.Payment != nil {
		toSerialize["payment"] = o.Payment
	}
	if o.Product != nil {
		toSerialize["product"] = o.Product
	}
	if o.ProductOffering != nil {
		toSerialize["productOffering"] = o.ProductOffering
	}
	if o.ProductOfferingQualificationItem != nil {
		toSerialize["productOfferingQualificationItem"] = o.ProductOfferingQualificationItem
	}
	if o.ProductOrderItem != nil {
		toSerialize["productOrderItem"] = o.ProductOrderItem
	}
	if o.ProductOrderItemRelationship != nil {
		toSerialize["productOrderItemRelationship"] = o.ProductOrderItemRelationship
	}
	if o.Qualification != nil {
		toSerialize["qualification"] = o.Qualification
	}
	if o.QuoteItem != nil {
		toSerialize["quoteItem"] = o.QuoteItem
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableProductOrderItem struct {
	value *ProductOrderItem
	isSet bool
}

func (v NullableProductOrderItem) Get() *ProductOrderItem {
	return v.value
}

func (v *NullableProductOrderItem) Set(val *ProductOrderItem) {
	v.value = val
	v.isSet = true
}

func (v NullableProductOrderItem) IsSet() bool {
	return v.isSet
}

func (v *NullableProductOrderItem) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProductOrderItem(val *ProductOrderItem) *NullableProductOrderItem {
	return &NullableProductOrderItem{value: val, isSet: true}
}

func (v NullableProductOrderItem) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProductOrderItem) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


